apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: {{ include "wso2-apim.fullname" . }}-analytics-worker
  labels:
    {{- include "wso2-apim.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      {{- include "wso2-apim.selectorLabelsAnalyticsWorker" . | nindent 6 }}
  serviceName: {{ include "wso2-apim.fullname" . }}-analytics-worker-headless
  template:
    metadata:
      labels:
        {{- include "wso2-apim.selectorLabelsAnalyticsWorker" . | nindent 8 }}
    spec:
    {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
    {{- end }}
      serviceAccountName: {{ include "wso2-apim.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      initContainers:
        - name: init-mysql-connector-download
          image: busybox:1.32
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          command:
            - /bin/sh
            - "-c"
            - |
              set -e
              connector_version=8.0.17
              wget https://repo1.maven.org/maven2/mysql/mysql-connector-java/${connector_version}/mysql-connector-java-${connector_version}.jar -P /mysql-connector-jar/
          volumeMounts:
            - name: mysql-connector-jar
              mountPath: /mysql-connector-jar
      containers:
        - name: {{ .Chart.Name }}-analytics-worker
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}-analytics-worker:{{ .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          env:
            - name: NODE_IP
              valueFrom:
                fieldRef:
                  fieldPath: status.podIP
            - name: NODE_ID
              valueFrom:
                fieldRef:
                  fieldPath: metadata.name
          ports:
            - containerPort: 9764
              protocol: "TCP"
            - containerPort: 9444
              protocol: "TCP"
            - containerPort: 7612
              protocol: "TCP"
            - containerPort: 7712
              protocol: "TCP"
            - containerPort: 9090
              protocol: "TCP"
            - containerPort: 7071
              protocol: "TCP"
            - containerPort: 7444
              protocol: "TCP"
          livenessProbe:
            exec:
              command:
                - /bin/sh
                - -c
                - nc -z localhost 9444
            initialDelaySeconds: 180
            periodSeconds: 10
            failureThreshold: 3
            timeoutSeconds: 5
          readinessProbe:
            exec:
              command:
                - /bin/sh
                - -c
                - nc -z localhost 9444
            initialDelaySeconds: 180
            periodSeconds: 10
            failureThreshold: 3
            successThreshold: 1
            timeoutSeconds: 1
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          volumeMounts:
            - name: wso2am-analytics-worker-conf
              mountPath: /home/wso2carbon/wso2-config-volume/conf/worker/deployment.yaml
              subPath: deployment.yaml
            - name: wso2am-analytics-worker-bin
              mountPath: /home/wso2carbon/wso2-config-volume/wso2/worker/bin/carbon.sh
              subPath: carbon.sh            
            - name: mysql-connector-jar
              mountPath: /home/wso2carbon/wso2-artifact-volume/lib
      volumes:
        - name: wso2am-analytics-worker-conf
          configMap:
            name: {{ include "wso2-apim.fullname" . }}-analytics-worker-conf
        - name: wso2am-analytics-worker-bin
          configMap:
            name: {{ include "wso2-apim.fullname" . }}-analytics-worker-bin        
        - name: mysql-connector-jar
          emptyDir: {}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
    {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
    {{- end }}
    {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
    {{- end }}
